/*!
 * node-tair - benchmark/utils.js
 * Copyright(c) 2013 Alibaba Group Holding Limited.
 * Author: 苏千 <suqian.yf@taobao.com> (http://fengmk2.github.com)
 */

"use strict";

/**
 * Module dependencies.
 */

var Benchmark = require('benchmark');
var should = require('should');
var utils = require('../lib/utils');

var suite = new Benchmark.Suite();

var b = new Buffer([0, 4, 110, 111, 100, 101, 45, 116, 97, 105, 114, 45, 102, 111, 111, 45, 106, 97, 118, 97]);
utils.murmurhash2(b).should.equal(426136330);

suite
.add('murmurhash2()', function () {
  utils.murmurhash2(b);
})

// add listeners
.on('cycle', function (event) {
  console.log(String(event.target));
})
.on('complete', function () {
  console.log('[%s] Fastest is "%s"', Date(), this.filter('fastest').pluck('name'));
})
.run({ async: true });

// $ node benchmark/utils.js 
// murmurhash2() x 4,582,506 ops/sec ±0.33% (98 runs sampled)
// [Sun Oct 27 2013 10:31:04 GMT+0800 (CST)] Fastest is "murmurhash2()"
