/*!
 * node-tair - example/demo.js
 * Copyright(c) 2013 fengmk2 <fengmk2@gmail.com> (http://fengmk2.github.com)
 * MIT Licensed
 */

"use strict";

/**
 * Module dependencies.
 */

var Tair = require('../');

var tair = new Tair({
  dataId: 'market2-daily',
  diamond: 'commonconfig.taobao.net:8080',
  namespace: 171,
  syncInterval: 5000,
}).on('connect', function () {
  tair.get('foo', function (err, data) {
    console.log('get foo:', err, data && data.toString());
  });

  tair.put('foo', 'foo bar', function (err, res) {
    console.log('put foo bar:', err, res);
  });

  tair.get('node-tair-expired-1', function (err, data) {
    console.log('get node-tair-expired-1:', err, data && data.toString());
  });

  tair.get('node-tair-invalid-test', function (err, data) {
    console.log('get node-tair-invalid-test:', err, data && data.toString());
  });

  tair.invalid('node-tair-invalid-test', function (err, success) {
    console.log('get node-tair-invalid-test:', err, success);
  });
});

setTimeout(function () {
  tair.close();
}, 10000);