/**!
 * node-tair - index.js
 *
 * Copyright(c) 2013 Alibaba Group Holding Limited.
 * MIT Licensed
 *
 * Authors:
 *   fengmk2 <suqian.yf@taobao.com> (http://fengmk2.github.com)
 */

var Client = require('./lib/client');
var ClusterClient = require('./lib/cluster_client');

module.exports = function Tair(options) {
  if (options.dataId) {
    return new ClusterClient(options);
  } else {
    return new Client(options);
  }
};

module.exports.ConfigServer = require('./lib/servers/config_server');
module.exports.DataNode = require('./lib/servers/data_node');
module.exports.Transcoder = require('./lib/packets/transcoder');
module.exports.middlewares = {
  accesslog: require('./lib/servers/middlewares/accesslog'),
};
