/*!
 * node-tair - lib/packets/remove.js
 *
 * Copyright(c) 2013 Alibaba Group Holding Limited.
 * MIT Licensed
 *
 * Authors:
 *   fengmk2 <suqian.yf@taobao.com> (http://fengmk2.github.com)
 */

"use strict";

/**
 * Module dependencies.
 */

var util = require('util');
var Get = require('./get');
var cons = require('../const');

/**
 * Remove packet
 *
 * @param {String|Buffer|Number} key
 * @param {Transcoder} transcoder
 * @param {Object} [options]
 *  - {Number} [namespace] default is 0
 */
function Remove(key, transcoder, options) {
  Get.call(this, key, transcoder, options);
  this.isRead = false;
  this.code = cons.TAIR_REQ_REMOVE_PACKET;
}

util.inherits(Remove, Get);

module.exports = Remove;
