/**!
 * node-tair - lib/servers/request.js
 *
 * Copyright(c) 2013 Alibaba Group Holding Limited.
 * Authors:
 *   苏千 <suqian.yf@taobao.com> (http://fengmk2.github.com)
 */

"use strict";

/**
 * Module dependencies.
 */

var Codes = require('./codes');

function TairRequest(id, code, body, transcoder, socket) {
  this.id = id;
  this.code = code;
  var pkg = Codes[code];
  if (pkg) {
    this.name = pkg.name;
    this.data = pkg.class.unpack(body, transcoder);
  }
  this.socket = socket;
  this.remoteAddress = socket.remoteAddress;
  this.remotePort = socket.remotePort;
}

module.exports = TairRequest;
