/*!
 * node-tair - test/longrunning.js
 *
 * Copyright(c) 2013 Alibaba Group Holding Limited.
 * MIT Licensed
 *
 * Authors:
 *   fengmk2 <suqian.yf@taobao.com> (http://fengmk2.github.com)
 */

"use strict";

/**
 * Module dependencies.
 */

var Tair = require('../');

var client = new Tair({
  dataId: 'tmall2-daily',
  diamond: 'commonconfig.taobao.net:8080',
  namespace: 171,
});

var now = '1';

var putIndex = 0;
function callPut() {
  var j = putIndex++;
  var key = 'node-tair-test-' + j;
  // console.log(key)
  if (j % 1000 === 0) {
    console.time(key);
  }
  var data = JSON.stringify({
    'history': 'history ' + key + ' ' + j,
    'qualifier2': 'qualifier2 ' + key + ' ' + j,
  });
  // console.log(key, data)
  client.put(key, data, function (err) {
    if (err) {
      throw err;
    }
    if (j % 1000 === 0) {
      console.timeEnd(key);
    }
  });
}

function callPrefixPuts() {
  var j = putIndex++;
  var key = 'node-tair-test-prefix-' + j;
  // console.log(key)
  if (j % 1000 === 0) {
    console.time(key);
  }
  var values = [
    ['history', 'history' + key + ' ' + j],
    ['qualifier', 'qualifier2 ' + key + ' ' + j,]
  ];
  // console.log(key, data)
  client.prefixPuts(key, values, function (err) {
    if (err) {
      throw err;
    }
    if (j % 1000 === 0) {
      console.timeEnd(key);
    }
  });
}

var i = 0;
var done = 0;
var totalUse = 0;
function callGet() {
  var key = 'node-tair-test-' + i++;
  var start = Date.now();
  client.get(key, function (err, data) {
    done++;
    var use = Date.now() - start;
    totalUse += use;
    if (err) {
      throw err;
    }

    // console.log(key, data && data.toString());
    // console.log(key, data.toString())
    if (done % 100 === 0) {
      console.log('%d %s %sms', done, data, (totalUse / done).toFixed(2));
    }
  });
}

function callPrefixGets() {
  var key = 'node-tair-test-prefix-' + i++;
  var start = Date.now();
  client.prefixGets(key, ['history', 'qualifier'], function (err, data) {
    done++;
    var use = Date.now() - start;
    totalUse += use;
    if (err) {
      throw err;
    }
    if (done % 100 === 0) {
      // console.log(key, data);
      console.log('%d %s:%j, rt: %sms', done, key, data, (totalUse / done).toFixed(2));
    }
  });
}

client.on('connect', function () {
  callPut();
});

setTimeout(function () {
  setInterval(function () {
    callGet();
    // callPut();
    // callPrefixPuts();
    // callPrefixGets();
  }, 5);
}, 1000);
