/*!
 * node-tair - test/packets/get.test.js
 * Copyright(c) 2013 Alibaba Group Holding Limited.
 * MIT Licensed
 *
 * Authors:
 *   fengmk2 <suqian.yf@taobao.com> (http://fengmk2.github.com)
 */

"use strict";

/**
 * Module dependencies.
 */

var should = require('should');
var Get = require('../../lib/packets/get');
var Transcoder = require('../../lib/packets/transcoder');
var MixedKey = require('../../lib/packets/mixed_key');
var cons = require('../../lib/const');

describe('packets/get.test.js', function () {
  it('should encode mixed key bytes match java bytes', function () {
    var bodyLength = 59;
    var groupName = 'group_market2';
    var pkey = '320';
    var skey = 'uid';
    var chid = 2;
    var namespace = 171;
    var javaBytes = new Buffer([109, 66, 100, 84, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 59, 0, 0,
      -85, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, -64, 0, 12, 0, 24, 0, 4, 51, 50, 48, 0, 4, 117, 105, 100]);

    var transcoder = new Transcoder();
    var key = new MixedKey(transcoder, pkey, skey);
    var get = new Get(key, transcoder, {namespace: namespace});
    var buf = get.encode(chid);
    buf.should.eql(javaBytes);
  });
});
