/**!
 * node-tair - test/packets/get_group.test.js
 *
 * Copyright(c) 2013 Alibaba Group Holding Limited.
 * Authors:
 *   苏千 <suqian.yf@taobao.com> (http://fengmk2.github.com)
 */

"use strict";

/**
 * Module dependencies.
 */

var ByteBuffer = require('byte');
var should = require('should');
var GetGroup = require('../../lib/packets').GetGroup;

describe('packets/get_group.test.js', function () {
  it('should pack and decode it', function (done) {
    var servers = [
      {host: '127.0.0.1', port: 3456},
      {host: '127.0.0.2', port: 3456},
    ];
    var group = {
      bucket: servers.length,
      copy: 1,
      version: 1,
      configCount: 0,
      servers: servers
    };
    GetGroup.asyncPack(group, null, function (err, body) {
      should.not.exist(err);
      var g = new GetGroup(0, 'test');
      g.asyncDecode(ByteBuffer.wrap(body), function (err, res) {
        should.not.exist(err);
        res.servers.should.eql([
          [{host: 16777343, port: 3456}, {host: 33554559, port: 3456}], []
        ]);
        res.bucket.should.equal(2);
        res.copy.should.equal(1);
        // console.log(res.servers)
        done();
      });
    });
  });
});
