/*!
 * node-tair - test/packets/invaild.test.js
 * Copyright(c) 2013 Alibaba Group Holding Limited.
 * MIT Licensed
 *
 * Authors:
 *   fengmk2 <suqian.yf@taobao.com> (http://fengmk2.github.com)
 */

"use strict";

/**
 * Module dependencies.
 */

var should = require('should');
var Invalid = require('../../lib/packets/invalid');
var Transcoder = require('../../lib/packets/transcoder');
var cons = require('../../lib/const');

describe('packets/invalid.test.js', function () {
  it('should encode bytes match java bytes', function () {
    var bodyLength = 93;
    var groupName = 'group_market2';
    var key = 'node-tair-invalid-test';
    var chid = 2;
    var namespace = 171;
    var javaBytes = new Buffer([109, 66, 100, 84, 0, 0, 0, 2, 0, 0, 0, 23, 0, 0, 0, 93, 0, 0,
      -85, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 0, 4, 110, 111, 100, 101, 45, 116, 97,
      105, 114, 45, 105, 110, 118, 97, 108, 105, 100, 45, 116, 101, 115, 116, 0, 0, 0, 14,
      103, 114, 111, 117, 112, 95, 109, 97, 114, 107, 101, 116, 50, 0, 0, 0, 0, 0]);

    var invalid = new Invalid(key, groupName, new Transcoder(), {namespace: 171});
    var buf = invalid.encode(chid);
    buf.should.eql(javaBytes);
  });
});
