/*!
 * node-tair - test/packets/prefix_get.test.js
 * Copyright(c) 2013 Alibaba Group Holding Limited.
 * MIT Licensed
 *
 * Authors:
 *   fengmk2 <suqian.yf@taobao.com> (http://fengmk2.github.com)
 */

"use strict";

/**
 * Module dependencies.
 */

var should = require('should');
var PrefixGet = require('../../lib/packets/prefix_get');
var Transcoder = require('../../lib/packets/transcoder');
var MixedKey = require('../../lib/packets/mixed_key');
var cons = require('../../lib/const');

describe('packets/prefix_get.test.js', function () {
  it('should encode mixed key bytes match java bytes', function () {
    var bodyLength = 114;
    var pkey = '320';
    var skey = 'uid';
    var chid = 3;
    var namespace = 171;
    var javaBytes = new Buffer([109, 66, 100, 84, 0, 0, 0, 3, 0, 0, 0, 29, 0, 0, 0, 114, 0, 0, -85,
      0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 1, -64, 0, 15, 0, 24, 0, 4, 51, 50, 48, 0, 4, 117, 105, 100, 115, 116, 114,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      1, -64, 0, 12, 0, 24, 0, 4, 51, 50, 48, 0, 4, 117, 105, 100]);

    var transcoder = new Transcoder();
    var keys = [
      new MixedKey(transcoder, '320', 'uidstr'),
      new MixedKey(transcoder, '320', 'uid'),
    ];
    var get = new PrefixGet(keys, transcoder, {namespace: namespace});
    var buf = get.encode(chid);
    buf.should.eql(javaBytes);
  });
});
