/*!
 * node-tair - test/packets/transcoder.test.js
 * Copyright(c) 2013 Alibaba Group Holding Limited.
 * MIT Licensed
 * 
 * Authors: 
 *   苏千 <suqian.yf@taobao.com> (http://fengmk2.github.com)
 */

"use strict";

/**
 * Module dependencies.
 */

var should = require('should');
var Transcoder = require('../../lib/packets/transcoder');
var MixedKey = require('../../lib/packets/mixed_key');

describe('packets/transcoder.test.js', function () {
  before(function () {
    this.transcoder = new Transcoder();
  });

  describe('encode()', function () {
    it('should encode string match java bytes', function () {
      var bytes = new Buffer([0, 4, 110, 111, 100, 101, 45, 116, 97, 105, 114, 45, 102, 111, 111, 45, 106, 97, 118, 97]);
      this.transcoder.encode('node-tair-foo-java').should.eql(bytes);
      bytes = new Buffer([0, 4, 110, 111, 100, 101, 45, 116, 97, 105, 114, 45, 105, 110, 118, 97, 108, 105, 100, 45, 116, 101, 115, 116]);
      this.transcoder.encode('node-tair-invalid-test').should.eql(bytes);
    });

    it('should encode mixed key match java bytes', function () {
      var bytes = new Buffer([0, 24, 0, 4, 51, 50, 48, 0, 4, 117, 105, 100]);
      var pkey = '320';
      var skey = 'uid';
      var mk = new MixedKey(this.transcoder, pkey, skey);
      this.transcoder.encode(mk, false).should.eql(bytes);
    });
  });
});
